diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/extract-section smixx/src/tclTkGUI/extract-section
--- smixx_web/src/tclTkGUI/extract-section	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/extract-section	2006-12-06 11:42:14.000000000 +0100
@@ -0,0 +1,41 @@
+#! /bin/tcsh -f
+
+set FILE = ${1}
+set firstLine = ${2}
+set lastLine = ${3}
+
+#echo $FILE
+#echo $firstLine
+#echo $lastLine
+
+set nl = `wc -l $FILE | awk '{print $1}'`
+if ( $lastLine == "end" ) then
+	set lastLine = $nl
+endif
+
+if ( $nl >= $lastLine ) then
+	@ numLinesToExtract = ($lastLine - $firstLine) + 1
+else
+	@ numLinesToExtract = ($nl - $firstLine) + 1
+endif
+
+#echo $nl
+
+#echo $numLinesToExtract
+
+#Num of lines starting from firstline to the end nl-firstline+1
+@ numLinesFromFirst = ($nl - $firstLine) + 1 
+
+#echo $numLinesFromFirst
+
+#extract the lines starting with the first to the end of file
+
+set TMP = /tmp/FILE$$
+
+tail -n $numLinesFromFirst $FILE > $TMP
+
+# now extract the rest
+head -n $numLinesToExtract $TMP
+
+rm -f $TMP
+exit
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/listBox_create.tcl smixx/src/tclTkGUI/listBox_create.tcl
--- smixx_web/src/tclTkGUI/listBox_create.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/listBox_create.tcl	2007-02-18 09:07:55.000000000 +0100
@@ -0,0 +1,30 @@
+#==============================================================================
+#
+#                                  Boda Franek    December 2006
+# Copyright Information:
+#      Copyright (C) 2005-2006 CCLRC.   All Rights Reserved
+#
+#    $Id: listBox_create.tcl,v 1.5 2007/02/18 08:07:55 franek Exp $
+#==============================================================================
+#===================================================================================
+proc listBox_create {win title} {
+     
+	frame $win -borderwidth 1
+		set labelId [label $win.label -text $title]
+		pack $labelId
+		
+		set listBoxId $win.listb
+		set scrollId $win.scroll
+		
+		listbox $listBoxId -yscroll "$scrollId set" -setgrid 1 -height 5 -width 20 -bg white
+		scrollbar $scrollId -command "$listBoxId yview"
+
+		pack $scrollId -side right -fill y -pady 5 
+
+		pack $listBoxId -side left -fill both -expand 1 -pady 5
+	return $win
+}
+#=============================================================================
+proc listBox_input {win} {
+	return "$win.listb"
+}
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/main.tcl.in smixx/src/tclTkGUI/main.tcl.in
--- smixx_web/src/tclTkGUI/main.tcl.in	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/main.tcl.in	2007-03-19 10:01:48.000000000 +0100
@@ -0,0 +1,165 @@
+#! /usr/bin/wish -f
+#==============================================================================
+# Generic SMI GUI
+#
+#                                  Boda Franek    December 2005
+# Copyright Information:
+#      Copyright (C) 2005 CCLRC.   All Rights Reserved
+#
+#    $Id: main.tcl,v 1.1 2006/03/21 11:27:03 franek Exp $
+#==============================================================================
+global objects
+set hel10font [font create hel10font -family helvetica -size 10]
+set helbold10font [font create helbold10font -family helvetica -size 10 -weight bold]
+
+set hel12font [font create hel12font -family helvetica -size 12]
+set helbold12font [font create helbold12font -family helvetica -size 12 -weight bold]
+
+option add *Label.font $hel12font
+option add *Label.borderwidth 2
+option add *Label.relief sunken
+#==============================================================================
+proc create_objectWidg { win object widthd widtho } {
+    global objectId
+    frame $win
+        puts stdout "Registering $object"
+        set objectId($object) $win
+	set domobj [split $object :]
+	set domain [lindex $domobj 0]
+	set name [lindex $domobj 2]
+	label $win.domain -width $widthd -text $domain
+        label $win.name -width $widtho -text $name
+        label $win.state -width 20 -text "dummy"
+        button $win.param -text "Parameters" -width 10
+        menubutton $win.act -text "Actions" -width 7 -menu $win.act.menu
+        menu $win.act.menu -postcommand "actionMenu_update $win.act.menu $object"
+    
+        pack $win.domain $win.name $win.state $win.act $win.param -side left -padx 2
+	
+    return $win
+}
+#========================================================================================
+proc actionMenu_update {win object} {
+    set actions [getObjectActions $object]
+
+    $win delete 0 last
+
+    $win add command -label "$object - actions"
+    $win add separator
+    foreach action $actions {
+        $win add command -label $action -command "actionCommand $object $action" 
+    }
+    return
+}
+#=======================================================================================
+proc actionCommand {object action} {
+
+#tk_messageBox -message "object $object  action $action"
+    set parameters [getActionParameters $object $action]
+tk_messageBox -message $parameters
+    return
+}
+#=======================================================================================
+proc update_objectWidg { object } {
+    global objectId
+    
+    set win $objectId($object)
+    $win.state configure -text [getState $object]
+    return
+}
+#============================================================================    
+proc userUpdate { type object } {
+    global objectId
+    if {![info exists objectId($object)]} {
+        puts stdout "Object <$object> is not registered"
+	return
+    }
+    puts stdout "$type $object"
+    puts stdout [getState $object]
+    update_objectWidg $object
+    return
+}
+#=============================================================================
+proc getObjects { } {
+    global platform testRun
+    global argc argv env
+    global objects maxDomain maxObjName
+    
+#    puts stdout " $argc    $argv"
+
+    
+    if { $argc >= 1 } {
+        set inObjectFile [lindex $argv 0]
+	puts stdout $inObjectFile
+    }
+    
+    if { $argc == 0 && $platform == "windows" && $testRun == 1} {
+        set inObjectFile $env(HOME)/Desktop/objectList.txt
+    }
+#    lappend objects BODA::OBJECT
+#    lappend objects BABAR::RUN_CONTROL
+#    set maxDomain 7
+#    set maxObjName 18
+
+    set inObjectFileId [open $inObjectFile]
+ 
+    set maxDomain 0
+    set maxObjName 0
+       
+    while { [gets $inObjectFileId objName] > -1 } {
+        puts stdout $objName
+        lappend objects $objName
+	set domobj [split $objName :]
+	set domain [lindex $domobj 0]
+	set name [lindex $domobj 2]
+	set lendomain [string length $domain]
+	set lenname [string length $name]
+	if { $lendomain > $maxDomain } {
+	    set maxDomain $lendomain
+	}
+	if { $lenname > $maxObjName } {
+	    set maxObjName $lenname
+	}
+    }
+    incr maxDomain 3
+    incr maxObjName 3
+    return
+}
+#=============================================================================
+proc createObjectWidg {} {
+    global objects maxDomain maxObjName
+    
+    set num 0
+    foreach object $objects {
+        incr num
+        create_objectWidg .object$num $object $maxDomain $maxObjName
+	registerObject $object
+	pack .object$num
+    }
+    return
+}
+#==========================================================================    
+global smitcldir 
+set prefix "@prefix@"
+set smitcldir "@datadir@/@PACKAGE@"
+if { [info exists env(SMIDIR)] } {
+    set smitcldir $env(SMIDIR)/src/tclTkGUI/
+}
+source $smitcldir/tcl-smi.tcl
+
+global testRun
+global platform
+
+set testRun 1
+
+set platform $tcl_platform(platform)
+if { $platform != "windows" && $platform != "unix" } {
+    tk_messageBox -message "Unsupported Platform $platform"
+    exit
+}
+
+getObjects
+createObjectWidg
+
+startMonitoring
+
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/mainPanel.tcl smixx/src/tclTkGUI/mainPanel.tcl
--- smixx_web/src/tclTkGUI/mainPanel.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/mainPanel.tcl	2007-02-16 11:48:01.000000000 +0100
@@ -0,0 +1,93 @@
+#==============================================================================
+# Generic SMI GUI
+#
+#                                  Boda Franek    December 2006
+# Copyright Information:
+#      Copyright (C) 2005 - 2006 CCLRC.   All Rights Reserved
+#
+#    $Id: mainPanel.tcl,v 1.13 2007/02/16 10:48:01 franek Exp $
+#==============================================================================
+proc mainPanel_create {win} {
+	
+	frame $win
+		set titId [title_create $win.tit]
+		pack $titId
+		
+		set buttonsId [mainPanelButtons_create $win.buts]
+		
+		frame $win.sep -height 2 -borderwidth 1 -relief sunken
+		pack $win.sep -fill x -pady 4
+
+		label $win.butslab -text "Object Selection" -relief flat -pady 4
+		pack $win.butslab		
+		pack $buttonsId 
+	return $win
+}
+#============================================================================
+proc title_create {win} {
+	global GUIdir
+	global hel32font
+
+	frame $win
+		set logoGif $GUIdir/SMIXXLogo.gif
+		set im [image create photo -file $logoGif]
+		label $win.pic -image $im -relief flat
+		label $win.gui -text "Generic GUI" -font hel32font  -padx 20 -relief flat
+		pack $win.pic $win.gui -side left
+	return $win
+}
+#=========================================================================================
+proc mainPanelButtons_create {win} {
+	
+	frame $win	
+		
+		set labentry $win.labentry
+		frame $labentry
+			label $labentry.l -text "Enter object manually:" -relief flat
+			entry $labentry.e -textvariable entObject -bg white
+			pack $labentry.l $labentry.e -side top
+			bind $labentry.e <Return> {addObject $entObject}
+			bind $labentry.e <FocusIn> "$labentry.e configure -bg azure2"
+			bind $labentry.e <FocusOut> "$labentry.e configure -bg white"
+
+		button $win.addObjects -text "Browse" -command browseForObjects
+		pack $labentry -side left -padx 20
+		pack $win.addObjects -side left -padx 20
+		
+		button $win.fromFile -text "From File" -command retrieveConfiguration
+		pack $win.fromFile -side left -padx 20
+	return $win
+}
+#===========================================================================================
+proc retrieveConfiguration {} {
+	
+	set filename [tk_getOpenFile -title "Objects from Configuration File"]
+	puts stdout $filename
+	if { $filename == "" } {
+		return
+	}
+	if [catch {open $filename r} chanId] {
+		tk_messageBox -message "cannot open $filename : $chanId"
+		return
+	}
+	
+	while { [ gets $chanId objName ] >= 0} {
+		addObject $objName	
+	}
+	
+	close $chanId
+	return
+}
+#===========================================================================================
+proc browseForObjects {} {
+	set selection [ objectSelectionPanel_show ]
+	
+	if { $selection != "" } { 
+		foreach obj $selection {
+			addObject $obj
+		}
+	}
+
+	return
+}
+	
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/makeExecutable smixx/src/tclTkGUI/makeExecutable
--- smixx_web/src/tclTkGUI/makeExecutable	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/makeExecutable	2007-02-16 11:45:33.000000000 +0100
@@ -0,0 +1,47 @@
+#! /bin/tcsh -f
+
+# It will take the main.tcl and replace the source statements by
+# the actual code
+
+
+set GUIdir = $SMIDIR/src/tclTkGUI
+set efftcldir = $SMIDIR/src/utilities/efftcl
+
+set MAIN = $GUIdir/main.tcl
+set PART1 = /tmp/PART1$$
+set PART2 = /tmp/PART2$$
+set PART3 = /tmp/PART3$$
+
+set SOURCEINS = /tmp/SOURCEINS$$
+
+set FINALGUI = /tmp/smiGUI.tcl$$
+
+set first = `grep -n sourced-files-beg $MAIN| sed 's/:/ /' |awk '{print $1}'`
+set last = `grep -n sourced-files-end $MAIN| sed 's/:/ /' |awk '{print $1}'`
+
+set first1 = $first
+set last1 = $last
+
+@ first1++
+@ last1--
+
+#echo $first
+#echo $last
+
+$GUIdir/extract-section $MAIN 1 $first > $PART1
+$GUIdir/extract-section $MAIN $first1 $last1 > $SOURCEINS
+$GUIdir/extract-section $MAIN $last end > $PART3
+
+
+$GUIdir/assemble $SOURCEINS $GUIdir $efftcldir > $PART2
+
+cat $PART1 > $FINALGUI
+cat $PART2 >> $FINALGUI
+cat $PART3 >> $FINALGUI
+
+chmod a+x $FINALGUI
+cp $FINALGUI ${SMIDIR}/${ODIR}/smiGUI.tcl
+cp $GUIdir/*.gif  ${SMIDIR}/${ODIR}/.
+
+exit
+
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/objectParPanel_create.tcl smixx/src/tclTkGUI/objectParPanel_create.tcl
--- smixx_web/src/tclTkGUI/objectParPanel_create.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/objectParPanel_create.tcl	2007-01-25 12:57:42.000000000 +0100
@@ -0,0 +1,134 @@
+#====================================================================
+#
+#                           Boda Franek    Nov 2006
+# Copyright Information:
+#       Copyright (C) 2005 CCLRC. All Rights Reserved
+#
+#  $Id: objectParPanel_create.tcl,v 1.11 2007/01/25 11:57:42 franek Exp $
+#====================================================================
+#===============================================================================
+proc objectParPanel_create {win parameters title} {
+# The panel has 3 sections :
+#  1 - Heading
+#  2 - parameters
+#  3 - controls  OK and Cancel buttons
+#===============================================================================
+	set parGroupId $win
+
+	frame $win    
+		set info [objectParInfoPanel $win.info $parGroupId $parameters $title]
+		pack $info
+
+		set cntls $win.dismiss
+		button $cntls -text Dismiss -command "objectParPanel_destroy $win"
+
+		pack $cntls -side left -expand yes
+
+	return $win 
+}
+#===========================================================================
+proc objectParPanel_display {win parameters title} {
+
+	if { [winfo exists $win] } {
+		bell
+		wm deiconify $win
+		raise $win
+		update idletasks
+		return
+	}
+	
+	set parGroupId $win	
+	toplevel $win
+		set info [objectParInfoPanel $win.info $parGroupId $parameters $title]
+		pack $info
+
+		set cntls $win.dismiss
+		button $cntls -text Dismiss -command "objectParPanel_destroy $win"
+
+		pack $cntls -side left -expand yes
+		
+		wm protocol $win WM_DELETE_WINDOW "$cntls invoke"
+		
+	return $win
+}	
+#===========================================================================
+proc objectParPanel_destroy {win} {
+	
+	destroy $win
+	
+	set parGroupId $win
+	ParameterGroups::group_delete $parGroupId
+	return
+}
+#===========================================================================
+proc objectParOnlyPanel_create {win parGroupId parameters} {
+
+	frame $win
+	        objectParameterGroup_setup $parGroupId $parameters
+
+        	ParameterGroups::panel_create $win.parameters  $parGroupId
+        	pack $win.parameters
+	return $win
+}
+#===========================================================================
+proc objectParInfoPanel  {win parGroupId parameters title}	{
+	
+
+	frame $win
+
+		set parOnly [objectParOnlyPanel_create $win.parOnly $parGroupId $parameters]
+
+		frame $win.sep1 -height 2 -borderwidth 1 -relief sunken
+        	pack $win.sep1 -fill x -pady 4
+		
+		label $win.title -text $title -relief flat
+        	pack $win.title
+	        
+		frame $win.sep2 -height 2 -borderwidth 1 -relief sunken
+        	pack $win.sep2 -fill x -pady 4
+		
+		pack $parOnly
+		
+		frame $win.sep3 -height 2 -borderwidth 1 -relief sunken
+        	pack $win.sep3 -fill x -pady 4
+
+	return $win
+}		
+#======================================================================
+proc objectParameterGroup_setup {parGroupId parameters} {
+
+    foreach parm $parameters {	
+	set name [lindex $parm 0]
+	set type [lindex $parm 1]
+	set def [lindex $parm 2]
+	if { $def == "" } {
+		set def &noval
+	}	
+        
+#tk_messageBox -message " $name $def $type "
+        set id [string tolower $name]    
+
+         
+         ParameterGroups::parameter_create $parGroupId $id $name $type 9
+	 ParameterGroups::parameter_setInhibit $parGroupId $id
+         ParameterGroups::parameter_set $parGroupId $id $def
+    }
+}   
+#======================================================================
+proc objectParameterGroup_update {parGroupId parameters} {
+
+	foreach parm $parameters {	
+		set name [lindex $parm 0]
+		set type [lindex $parm 1]
+		set val [lindex $parm 2]
+		if { $val == "" } {
+			set val &noval
+		}	
+        
+#tk_messageBox -message " $name $def $type "
+		set id [string tolower $name]    
+
+		ParameterGroups::parameter_set $parGroupId $id $val
+	}
+	return
+}   
diff -xconfig -xrename -xgetDomains -xdomainExists -xgetSmiVersions -x'*-stamp' -x'config.*' -xCVS -x.cvsignore -xMakefile -x'.#*' -xtmp -xupdate.sh -xproxyExists -xlistDomain -xsmixx-31.01.tar.gz -xMakefile.in -xconfigure -xaclocal.m4 -r -w -u -N smixx_web/src/tclTkGUI/objectSelectionPanel.tcl smixx/src/tclTkGUI/objectSelectionPanel.tcl
--- smixx_web/src/tclTkGUI/objectSelectionPanel.tcl	1970-01-01 01:00:00.000000000 +0100
+++ smixx/src/tclTkGUI/objectSelectionPanel.tcl	2007-02-18 09:26:20.000000000 +0100
@@ -0,0 +1,268 @@
+
+#===============================================================================
+proc getDomainsForList {} {
+	set domainList [exec getDomains]
+		
+	set domains {}
+	
+	foreach item $domainList {
+		set splititem [split $item /]
+		set dom [lindex $splititem 0]
+		lappend domains $dom
+		set node($dom) [lindex $splititem 1]
+	}
+	set domainsSorted [lsort $domains]
+	return $domainsSorted
+}
+#==============================================================================
+proc getObjectsForList {domain} {
+	set domobjects [ exec getDomainObjects $domain ]
+	set domobjectsSorted [lsort $domobjects]
+	return $domobjectsSorted
+}
+proc selectAll {win} {
+}
+#===============================================================================
+proc objectSelectionLists_create { win } {
+	# The procedure creates three labelled and scrollabel lists side by side
+	global GUIdir
+	
+	frame $win
+		# Domains list ------------------------------------------------------
+		set domainsLabel [label $win.domainsLabel -text "Visible Domains"]
+		set  domains [Scrolled_Listbox $win.domains \
+			-width 20 -height 10 ]
+
+		# Domain objects list -----------------------------------------------
+		set objectsLabel [label $win.objectsLabel -text "Domain Objects"]
+		set objects [Scrolled_Listbox $win.objects \
+			-width 20 -height 10 -selectmode extended ]
+#			-width 20 -height 10 -selectmode extended -activestyle none]
+# older versions of Tcl/Tk do not support option '-activestyle'
+
+		# Selecting a domain will get the domain's objects and display them in objects
+		bind $domains <ButtonRelease-1> \
+			[list showDomainObjects %W $objects]
+
+		# Cntr-a will select all thw objects of the domain
+		bind $objects <Control-Key-a> \
+			[list %W selection set 0 end]
+
+		# Selected objects list ----------------------------------------------
+		set selObjectsLabel [label $win.selObjectsLabel -text "Selected Objects"]
+		set selObjects [Scrolled_Listbox $win.selObjects \
+			-width 20 -height 10 -selectmode extended]
+
+		# Selecting objects will remove them from the list
+		bind $selObjects <ButtonRelease-3> \
+			[list ListDeleteSel %W ]
+
+		# Right arrow button that will be placed in front of the selected objects list
+		if { [lsearch [image names] "::img::rightArrow"] == "-1" } {
+			set arrow [image create photo ::img::rightArrow -file $GUIdir/rightArrow.gif]
+		} else {
+			set arrow ::img::rightArrow
+		}
+		set selButton [button $win.selBut -image $arrow \
+			 -command [list transferSelectedItems $objects $selObjects] ]
+
+		set upDownButtons [upDownButtons_create $win.upDown $selObjects]
+
+		# place the elements on the frame
+		grid $win.domainsLabel -row 0 -column 0
+		grid $win.domains -row 1 -column 0
+
+		grid $win.objectsLabel -row 0 -column 1
+		grid $win.objects -row 1 -column 1
+
+		grid $selButton -row 1 -column 2 -padx 10
+
+		grid $win.selObjectsLabel -row 0 -column 3
+		grid $win.selObjects -row 1 -column 3
+
+		grid $upDownButtons -row 1 -column 4 -sticky ns
+
+		# Insert all the domains
+		set values [getDomainsForList]
+		foreach x $values {
+			$domains insert end $x
+		}
+
+	return $win
+}
+#==================================================================================
+proc upDownButtons_create {win selObjects} {
+	global GUIdir
+	
+	frame $win
+
+		# Up arrow button that will be placed behind of the selected objects list
+		if { [lsearch [image names] "::img::upArrow"] == "-1" } {
+			set uparrow [image create photo ::img::upArrow -file $GUIdir/upArrow.gif]
+		} else {
+			set uparrow ::img::upArrow
+		}
+		set upButton [button $win.upBut -image $uparrow \
+			 -command [list moveSelectedItemsUp $selObjects] ]
+
+		# down arrow button that will be placed behind of the selected objects list
+		if { [lsearch [image names] "::img::downArrow"] == "-1" } {
+			set downarrow [image create photo ::img::downArrow -file $GUIdir/downArrow.gif]
+		} else {
+			set downarrow ::img::downArrow
+		}
+		set downButton [button $win.downBut -image $downarrow \
+			 -command [list moveSelectedItemsDown $selObjects] ]
+		pack $upButton -anchor n -expand true
+		pack $downButton -anchor s -expand true
+	return $win
+}		
+#==================================================================================
+proc moveSelectedItemsUp {win} {
+	# the items selected
+	set selection [$win curselection]
+	
+	if { $selection == "" } {
+		bell
+		tk_messageBox -message "Select something!" -parent $win
+		return
+	}
+
+	set first [lindex $selection 0]
+	set last  [lindex $selection end]
+#tk_messageBox -message "$first  $last"
+
+	if { $first == "0" } {
+		bell
+		return
+	}
+
+	set itemabove [$win get [expr $first - 1]]
+#tk_messageBox -message $itemabove
+	$win insert [expr $last + 1] $itemabove
+	$win delete [expr $first - 1]
+	
+}
+#==================================================================================
+proc moveSelectedItemsDown {win} {
+	# the items selected
+	set selection [$win curselection]
+
+	if { $selection == "" } {
+		bell
+		tk_messageBox -message "Select something!" -parent $win
+		return
+	}
+
+
+	set first [lindex $selection 0]
+	set last  [lindex $selection end]
+#tk_messageBox -message "$first  $last  [$win size]"
+
+	if { $last >= [expr [$win size] - 1] } {
+		bell
+		return
+	}
+
+	set itembellow [$win get [expr $last + 1]]
+#tk_messageBox -message $itembellow
+	$win delete [expr $last + 1]
+	$win insert [expr $first] $itembellow
+
+	$win see [expr $last + 1]	
+}
+#================================================================================
+proc objectSelectionLists_selection {win} {
+	# the procedure returns the selected objects in a list
+	set src $win.selObjects.list
+
+	return [$src get 0 end]
+}
+#================================================================================
+proc showDomainObjects {src dst} {
+	# The procedure will find out the list of the objects for the selected domain and
+	# displays them in the appropriate list
+
+	#First clear the previous object list
+	$dst delete 0 end
+	update idletasks
+
+	# Find which domain was selected
+	set i [$src curselection]
+	set domain [$src get $i]
+
+	# Now get the domain objects
+	set objects [getObjectsForList $domain]
+	foreach obj $objects {
+		$dst insert end $obj
+	}
+	focus $dst
+}
+#================================================================================
+proc transferSelectedItems {src dst} {
+	# the procedure will transfer selected items from $src list to $dst list
+	# so far transferred
+	set all [$dst get 0 end]
+	
+	set selection [$src curselection]
+	if { $selection == "" } {
+		bell
+		tk_messageBox -message "Select something!" -parent $src
+		return
+	}
+	
+	foreach i  $selection {
+		set sel [$src get $i]
+		# make sure that the item has not been already selected
+		if { [lsearch $all $sel] == "-1" } {	
+			$dst insert end [$src get $i]
+		}
+	}
+
+	set size [$dst size]
+	$dst see $size
+	update idletasks
+}
+#================================================================================
+proc ListDeleteSel {w} {
+	foreach i [lsort -integer -decreasing [$w curselection]] {
+		$w delete $i
+	}
+}
+#=================================================================================
+proc objectSelectionPanel_show {} {
+	global objectSelectionPanelPrompt 
+
+	set top [dialog_create ObjectSelectionPanel]
+		set info [dialog_info $top]
+		set cntls [dialog_controls $top]
+		set win $top
+
+		set listBoxesId [objectSelectionLists_create $info.listBoxes ]
+
+		pack $listBoxesId -expand true -fill both	
+
+		button $cntls.ok -text OK -command {set objectSelectionPanelPrompt 1}
+		pack $cntls.ok -side left -expand yes
+
+		button $cntls.cancel -text Cancel -command {set objectSelectionPanelPrompt 2}
+		pack $cntls.cancel -side left -expand yes
+
+		set objectSelectionPanelPrompt 0
+		wm protocol $win WM_DELETE_WINDOW "$cntls.cancel invoke"
+
+		dialog_wait $win objectSelectionPanelPrompt
+
+		if { $objectSelectionPanelPrompt == "2" } {
+			set selection {}
+			return $selection
+		}
+
+		set selection [objectSelectionLists_selection $listBoxesId]
+		return $selection
+}
+#=================================================================================
+
+#button .b -text "Make Selection" -command {tk_messageBox -message [objectSelectionPanel_show]}
+#pack .b
+#==================================================================================================
